[Event("userItemAdded")]
[Effect("userItemAddedEffect")]

class com.iterationtwo.components.EditableComboBox extends mx.controls.ComboBox
{
	public var persistUserList:Boolean = false;
	public var addUserItemsToList:Boolean = true;

	public function EditableComboBox()
	{
		super();
		addEventListener( "initialize", myInitializeHandler );
		addEventListener( "enter", myEnterHandler );
	}

	private function myInitializeHandler( event )
	{
		addSharedObjectItems();
	}

	public function myEnterHandler( event )
	{
		addItemToCombo( event );
	}

	private function addItemToCombo( event )
	{
		if ( text.length > 0 && addUserItemsToList )
		{
			if ( !itemExistsInComboDataProvider( text ) )
			{
				addItem( text );

				if ( persistUserList )
				{
					var comboBoxSharedObject = SharedObject.getLocal( id );
					comboBoxSharedObject.data.dataProvider = dataProvider;
					comboBoxSharedObject.flush();
				}
				dispatchEvent( { type: "userItemAdded", item: text } );
			}
		}
	}

	private function addSharedObjectItems()
	{
		var comboBoxSharedObject = SharedObject.getLocal( id );
		if ( !persistUserList )
		{
			delete comboBoxSharedObject.data.dataProvider;
			return;
		}
		var sharedObjectDataProvider = comboBoxSharedObject.data.dataProvider;

		for ( var p in sharedObjectDataProvider )
		{
			if ( !itemExistsInComboDataProvider( sharedObjectDataProvider[p] ) )
				dataProvider.addItem( sharedObjectDataProvider[p] );
		}
	}

	private function itemExistsInComboDataProvider( item )
	{
		for ( var p in dataProvider )
		{
			if ( ( item == dataProvider[p] ) || ( item == dataProvider[p].label ) || ( item.label != undefined && item.label == dataProvider[p].label ) )
				return true;
		}
		return false;
	}

}