class SeatingDelegate
{

	public function SeatingDelegate()
	{
	}

	//------------------------------------------------------------

	public function getSeating( performanceId:Number, startTimeId:Number )
	{
		var seatingPlan = screenings[ performanceId ][ startTimeId ];
		return convertToSeatObjects( seatingPlan );
	}

	//------------------------------------------------------------

	public function showWheelchairAccess( view:Object )
	{
		var seatAlpha = 100;
		if ( view.showWheelchair.selected ) seatAlpha = 25;

		for( var i=0; i < midRow.length; i++ )
		{
			for( var j=0; j < 13; j++ )
			{
				var isWheelchairAccessRow = ( ( j== 4 ) || ( j == 8 ) );
				if (!isWheelchairAccessRow)
				{
					view.seat[j][i]._alpha = seatAlpha;
				}
			}
		}
	}

	//------------------------------------------------------------

	public function showLuxurySeats( view:Object )
	{
		var seatAlpha = 100;
		if ( view.showLuxury.selected ) seatAlpha = 25;

		for( var i=0; i < midRow.length; i++ )
		{
			for( var j=0; j < 13; j++ )
			{
				var isLuxury = ( ( j== 8) || ( j == 9 ) ) &&
								( (i > 4) && ( i <  11) );
				if (!isLuxury)
				{
					view.seat[j][i]._alpha = seatAlpha;
				}
			}
		}
	}

	//------------------------------------------------------------

	public function showSeatAvailability( view:Object )
	{
		for( var i=0; i < midRow.length; i++ )
		{
			for( var j=0; j < 13; j++ )
			{
				view.seat[j][i]._alpha = getAlphaForSeat( view, j, i );
			}
		}
	}

	//------------------------------------------------------------

	public function getAlphaForSeat( view:Object, row:Number, seat:Number ) : Number
	{
		var seatAlpha = 100;
		if ( view.showLuxury.selected && !isLuxurySeat( row, seat ) ||
		     view.showWheelchair.selected && !isWheelchairAccessSeat( row ) )
		     seatAlpha = 25;

		return seatAlpha;
	}

	//------------------------------------------------------------

	private function isWheelchairAccessSeat( row:Number ) : Boolean
	{
		return ( row == 4 || row == 8 );
	}

	//------------------------------------------------------------

	private function isLuxurySeat( row:Number, seat:Number ) : Boolean
	{
		return ( row == 8 || row == 9 ) && ( seat > 4 &&  seat <  11 );
	}

	//------------------------------------------------------------

	/**
	  * This helper method takes a 2-dimensional array of Strings,
	  * and converts it to a 2-dimensional array of SeatVO objects,
	  * for passing back to the dataProvider in the MXML page.
	  */
	private function convertToSeatObjects( seatsAsStrings : Array ) : Array
	{

		var seats:Array = new Array( seatsAsStrings.length );

		for( var row=0; row < seatsAsStrings.length; row++ )
		{
			var thisRow:Array = seatsAsStrings[ row ];
			var thisRowAsSeats:Array = new Array( thisRow.length );
			for ( var column=0; column < thisRow.length; column++ )
			{
				thisRowAsSeats[ column ] = createSeatVO( thisRow[ column ] );
			}
			seats[ row ] = thisRowAsSeats;
		}

		return seats;
	}

	//------------------------------------------------------------

	private function createSeatVO( seatString: String )
	{
		var seat = new SeatVO();
		seat.isEmpty = true;

		if ( seatString == "l" )
		{
			seat.price = 9.99;
			seat.isLuxury = true;
			seat.icon = "l.jpg";
		}
		else if ( seatString == "r" )
		{
			seat.price = 6.99;
			seat.isLuxury = false;
			seat.icon = "r.jpg";
		}
		else if ( seatString == "o" )
		{
			seat.isEmpty = false;
			seat.icon = "o.jpg";
		}

		else if ( seatString == "x" )
		{
			seat.icon =  "x.jpg";
		}

		return seat;
	}

	//------------------------------------------------------------

	//
	// This information would really be sent back from a webservice or
	// RemoteObject call, and each element in row would be a seatObject,
	// rather than a simple string.  This serves as an example only.
	//
	// o = occupied seat, r = regular seat, l = luxury seat, x = no seat
	// Define the 4 different row layouts
	var frontRow = [ "x","x","x","r","r","r","r","r","r","r","r","r","r","x","x","x" ];
	var emptyRow = [ "x","x","x","x","x","x","x","x","x","x","x","x","x","x","x","x" ];
	var midRow   = [ "r","r","x","r","r","r","r","r","r","r","r","r","r","x","r","r" ];
	var poshRow  = [ "r","r","x","r","r","l","l","l","l","l","l","r","r","x","r","r" ];

	var populatedMidRow1 = [ "r","o","x","r","o","o","o","r","o","o","r","r","o","x","r","o" ];
	var populatedMidRow2 = [ "o","o","x","r","r","o","o","r","r","o","o","r","o","x","o","o" ];
	var populatedMidRow3 = [ "o","o","x","o","o","o","o","r","o","o","o","o","o","x","r","r" ];

	var populatedFrontRow1 = [ "x","x","x","o","o","o","r","r","o","o","r","o","o","x","x","x" ];
	var populatedFrontRow2 = [ "x","x","x","o","o","o","r","o","r","o","o","o","o","x","x","x" ];

	// Define the Cinema Layout in terms of it's rows of seats
	var seats = [
					frontRow, frontRow, frontRow,
					emptyRow,
					midRow, midRow, midRow,
					emptyRow,
					poshRow, poshRow,
					midRow, midRow, midRow
				];

	var seats1 = [
					frontRow, populatedFrontRow1, populatedFrontRow2,
					emptyRow,
					populatedMidRow1, populatedMidRow1, midRow,
					emptyRow,
					poshRow, poshRow,
					midRow, populatedMidRow1, midRow
				];

	var seats2 = [
					frontRow, populatedFrontRow1, populatedFrontRow2,
					emptyRow,
					populatedMidRow3, populatedMidRow2, populatedMidRow1,
					emptyRow,
					poshRow, poshRow,
					populatedMidRow3, populatedMidRow1, populatedMidRow2
				];

	var seats3 = [
					frontRow, frontRow, populatedFrontRow2,
					emptyRow,
					midRow, populatedMidRow1, midRow,
					emptyRow,
					poshRow, poshRow,
					midRow, populatedMidRow3, midRow
				];

	var LOTR        = [ seats1, seats2, seats3 ];
	var StarWars    = [ seats2, seats1, seats3 ];
	var Gladiator   = [ seats3, seats1, seats2 ];
	var LastSamurai = [ seats1, seats1, seats2 ];

	var screenings = [ LOTR, StarWars, Gladiator, LastSamurai ];
}