// Loan Calculation Delegate
// Note, these calculations are not intended to be accurate
// There are used to show data binding
//

class com.iterationtwo.banking.business.LoanDelegate
{
	public function LoanDelegate()
	{
	}

	public function getInterestRate( amount : Number, term : Number ) : Number
	{
		if ( amount == undefined || term == undefined )
			return 0;
			
		var middleRate:Number = 15.9;
		var changeForLoan:Number = ( 15000 - amount ) /  2000;
		var changeForTerm:Number = ( 40 - term ) / 15;
			
		var rate:Number = middleRate + changeForLoan + changeForTerm;
		
		return Math.round( rate * 10 ) / 10;
	}
		
	public function getMonthlyRepayment( amount : Number, term : Number ) : Number
	{
		if ( amount == undefined || term == undefined )
			return 0;

		var rate:Number = getInterestRate( amount, term ) / 100;
		var firstBit:Number = amount * rate * Math.pow( ( 1 + rate / 12 ), term );
		var secondBit:Number = 12 * ( Math.pow( ( 1 + rate / 12 ), term ) - 1 );
			
		return Math.round( firstBit / secondBit * 100 ) / 100;
	}

	public function getTotalRepayable( amount : Number, term : Number ) : Number
	{
		if ( amount == undefined || term == undefined )
			return 0;

		return getMonthlyRepayment( amount, term ) * term;
	}

	public function getRepaymentPlan( amount:Number, term:Number ):Array
	{
		if ( amount == undefined || term == undefined )
			return [];
			
		var monthlyRepayment:Number = getMonthlyRepayment( amount, term );
		var interestPayment:Number = ( ( monthlyRepayment * term ) - amount ) / term ; 
			
		var plan = new Array();
		for ( var i = 0; i <= term; i++ )
		{
			if ( i < term )
				amount = amount + interestPayment;

			var interestPart:Number = Math.round( monthlyRepayment * ( term - i ) / term * 100 ) / 100;
			plan.push( { month: ( i ), balance: Math.round( amount * 100 ) / 100, repayment: monthlyRepayment, interest: interestPart } );
			amount = amount - monthlyRepayment;

			if ( amount < 1 )
				amount = 0;
		}
			
		return plan;
	}
		
}