import com.iterationtwo.banking.vo.*;
import com.iterationtwo.banking.business.*;
import mx.managers.PopUpManager;

class com.iterationtwo.banking.business.AccountDelegate
{

	public function AccountDelegate( callingCommand:Responder )
	{
		this.delegate = mx.core.Application.application.services.accountDelegate;
		this.responder = callingCommand;
	}

	//------------------------------------------------------------
 
	public function getPortfolio() : Void
	{
		var pc = delegate.getAccountPortfolio();
		pc.resultHandler = mx.utils.Delegate.create( Object( this.responder ), this.responder.onResult );
	}

	//------------------------------------------------------------

	public function getTransactions( accountNumber :String ) : Array
	{
		return stubbedTransactions( "" );
	}
	
	public function makeTransfer() : Void
	{
		delegate.makeTransfer();
	}
	
	//====================================================================================
	
	public function stubbedPortfolio() : AccountPortfolioVO
	{
		var portfolio = new AccountPortfolioVO();
		
		var checking = new AccountVO();
		checking.accountNumber = "00100100";
		checking.sortCode="161616";
		checking.title="Checking Account";
		checking.transactions = stubbedTransactions( checking.title );
		
		var savings = new AccountVO();
		savings.accountNumber = "00100101";
		savings.sortCode="161617";
		savings.title="Savings Account";
		savings.transactions = stubbedTransactions( savings.title );
		
		var highInterest = new AccountVO();
		highInterest.accountNumber = "00100100";
		highInterest.sortCode="161616";
		highInterest.title="High Interest Account";
		highInterest.transactions = stubbedTransactions( highInterest.title );
		
		portfolio.accounts.push( checking );
		portfolio.accounts.push( savings );
		portfolio.accounts.push( highInterest );
		
		return portfolio;
	}
	
	//------------------------------------------------------------

	public function stubbedTransactions( title:String ) : Array
	{
		var transactions:Array = new Array();
		var balance:Number = 0;
		for ( var i=0; i < 100; i++ )
		{
			var transaction = new TransactionVO();
			transaction.date = new Date();
			transaction.description = title+" Transaction "+i;
			transaction.type = "CDT";
			transaction.amount = i*10;
			transaction.balance = balance + transaction.amount;
			
			transactions.push( transaction );
		}
		
		return transactions;
	}	

	//------------------------------------------------------------

    private var responder:Responder;
	private var delegate:Object;

}