﻿import com.iterationtwo.banking.control.*;
import com.iterationtwo.banking.commands.*;
import mx.events.*;

class com.iterationtwo.banking.control.BankingController
{
   public function BankingController()
	{
		commands = new Array();
		initialiseCommands();					
	}

//------------------------------------------------------------------------------
	
	private function initialiseCommands()
	{
		addCommand( "fetchPortfolio", new FetchPortfolioCommand() );
		addCommand( "displayStatement", new DisplayStatementCommand() );
		addCommand( "displayTransaction", new DisplayTransactionCommand() );
		addCommand( "makePayment", new PaymentCommand() );
		addCommand( "makeTransfer", new TransferCommand() );
	}

//------------------------------------------------------------------------------
	
	public function handleEvent( event:Event )
	{
		executeCommand( event );
	}

//------------------------------------------------------------------------------

	private function executeCommand( event:Event )
	{
		var command:Command = getCommand( event.type );
		command.execute( event );
	}

//------------------------------------------------------------------------------

	private function addCommand( commandName:String, commandRef:Command )
	{
		commands[ commandName ] = commandRef;
		EventBroadcaster.getInstance().addEventListener( commandName, this );
	}

//------------------------------------------------------------------------------

	private function getCommand ( commandName ):Command
	{
		var command:Command = commands[ commandName ];
		if ( command == null )
			trace( "Command not found for " + commandName );

		return command;
	}

//------------------------------------------------------------------------------
	
	private var commands:Array;
}
