
package com.iterationtwo.banking.business;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;

import com.iterationtwo.banking.vo.*;

public class AccountDelegate 
{
	public AccountDelegate()
	{	
	}
	
	public TestVO getTestVO()
	{
		TestVO test = new TestVO();
		test.test = "testvo success";
		return test;
		
	}
	public HashMap getAccountObject()
	{
		HashMap hs = new HashMap();
		hs.put( "msg", "Successful Object Response");
		
		return hs;
	}
	
	public String getAccountName()
	{
		return "successful call";
	}
	public AccountPortfolioVO getAccountPortfolio()
	{
		// this method would retrieve account portfolio for a
		// customer form enterprise datastore.
		//
		// For the purposes of this example, we'll "fake" a
		// portfolio of fictional accounts, using private
		// helper methods defined for this purpose.
		System.out.println( "Called getAccountPortfolio() for customer: ");
		AccountPortfolioVO portfolio = stubbedPortfolio();
		System.out.println( "Portfolio["+portfolio+"] with "+portfolio.getAccounts().size()+" accounts ");
		return stubbedPortfolio();
	}

	
	private AccountPortfolioVO stubbedPortfolio() 
	{
		AccountPortfolioVO portfolio = new AccountPortfolioVO();
		ArrayList accounts = new ArrayList();
		
		AccountVO checking = new AccountVO();
		checking.setAccountNumber( "00410410" );
		checking.setSortCode( "80-61-46");
		checking.setTitle( "i2Bank Checking Account" );
		checking.setTransactions( stubbedTransactions( "Checking Account" ) );
		accounts.add( checking );
		
		AccountVO saving = new AccountVO();
		saving.setAccountNumber( "00410411" );
		saving.setSortCode( "80-61-47");
		saving.setTitle( "i2Bank Savings Account" );
		saving.setTransactions( stubbedTransactions("Savings Account") );
		accounts.add( saving );
		
		AccountVO high = new AccountVO();
		high.setAccountNumber( "00410412" );
		high.setSortCode( "80-61-47");
		high.setTitle( "i2Bank High Interest Account" );
		high.setTransactions( stubbedTransactions("High Interest Account") );
		accounts.add( high );
		
		portfolio.setAccounts( accounts );
		return portfolio;
	
	}
	
	private ArrayList stubbedTransactions( String prefix ) 
	{
		ArrayList transactions = new ArrayList();
		double balance = 0.0;
		
		for( int i=0; i<100; i++)
		{
			TransactionVO transaction = new TransactionVO();
			transaction.setDate( new Date() );
			transaction.setAmount( i*10 );
			balance += i*10;
			transaction.setBalance( balance );
			transaction.setType( "CDT" );
			transaction.setDescription( prefix+" transaction "+i );
			
			transactions.add( transaction );
		}
		return transactions;
		
	} 
	
}
