import com.iterationtwo.banking.vo.*;
import com.iterationtwo.banking.business.*;
import mx.managers.PopUpManager;

class com.iterationtwo.banking.business.AccountDelegate
{

	public function AccountDelegate( callingCommand:Responder )
	{
		this.delegate = mx.core.Application.application.services.accountDelegate;
		this.responder = callingCommand;
	}

	//------------------------------------------------------------
 
	public function getPortfolio() : Void
	{
		var pc = delegate.getAccountPortfolio();

		pc.resultHandler = mx.utils.Delegate.create( Object( this.responder ), this.responder.onResult );
		pc.faultHandler = mx.utils.Delegate.create( this, this.onFault );
  
	  pc.onLogin = getPortfolio;
	}

	//------------------------------------------------------------
	
	private function onFault( faultEvent ) : Void
	{
	  if ( faultEvent.fault.faultcode == "Client.Authentication" ) 
	  {
		  var popup = PopUpManager.createPopUp( MovieClip( mx.core.Application.application ), LoginWindow, true, { onLogin: faultEvent.call.onLogin } );
		  
		  popup.move( 75, 110 );
		  popup.addEventListener( "loginWindowEvent", this );
	  }
	  else 
	  {
		  mx.core.Application.alert( "You cannot currently use the service, please contact your System Administrator (" + faultEvent.fault.faultcode + ")" );
	  }
	 
	  this.responder.onFault( faultEvent.fault );		
	}

	//------------------------------------------------------------

	private function loginWindowEvent( event ) 
	{
		if ( event.action == "login" ) 
		{
			delegate.setUsernamePassword( event.username, event.password );
		}
		else 
		{
			delegate.clearUsernamePassword();
		}
		
  	event.onLogin.apply( this );
  }

	//------------------------------------------------------------

  private var responder:Responder;
	private var delegate:Object;

}