﻿import com.iterationtwo.boe.control.*;
import com.iterationtwo.boe.commands.*;
import mx.events.*;

class com.iterationtwo.boe.control.BankingController
{
   public function BankingController()
	{
		commands = new Array();
		initialiseCommands();					
	}

//------------------------------------------------------------------------------
	
	private function initialiseCommands()
	{
		addCommand( "getCreditCards", new GetCreditCardsCommand() );
		addCommand( "getCreditCardsForDashboard", new GetCreditCardsForDashboardCommand() );
		addCommand( "getApplications", new GetApplicationsCommand() );
		addCommand( "getApplicationsOverTime", new GetApplicationsOverTimeCommand() );
		addCommand( "getApplicationCountPerCard", new GetApplicationCountPerCardCommand() );		
		addCommand( "filterApplications", new FilterApplicationsCommand() );
		addCommand( "addApplication", new AddApplicationCommand() );
		addCommand( "updateApplication", new UpdateApplicationCommand() );
	}

//------------------------------------------------------------------------------
	
	public function handleEvent( event:Event )
	{
		executeCommand( event );
	}

//------------------------------------------------------------------------------

	private function executeCommand( event:Event )
	{
		trace( "Controller.executeCommand " + event.type + " " + event.data );
		var command:Command = getCommand( event.type );
		command.execute( event );
	}

//------------------------------------------------------------------------------

	private function addCommand( commandName:String, commandRef:Command )
	{
		commands[ commandName ] = commandRef;
		EventBroadcaster.getInstance().addEventListener( commandName, this );
	}

//------------------------------------------------------------------------------

	private function getCommand ( commandName ):Command
	{
		var command:Command = commands[ commandName ];
		if ( command == null )
			trace( "Command not found for " + commandName );

		return command;
	}

//------------------------------------------------------------------------------
	
	private var commands:Array;
}
