class com.iterationtwo.validators.PostcodeValidator extends mx.validators.Validator
{
	public function doValidation( postcode:String ) : Void
	{
		PostcodeValidator.validatePostcode( this, postcode, null );		
	}
	
	public static function validatePostcode( validator, postcode:String, subField ) : Boolean
	{ 
		var test:String = postcode; 
		if ( test == undefined )
			test = "";

		var size = test.length
		var test = test.toUpperCase(); 
		
		while ( test.slice( 0, 1 ) == " " ) 
		{
			test = test.substr( 1, size - 1 );
			size = test.length
		}
		
		while( test.slice( size - 1, size ) == " " ) 
		{
			test = test.substr( 0, size - 1 );
			size = test.length
		}

		postcode = test;
		
		if ( size < 6 || size > 8 )
		{ 
			validator.validationError( "wrongLength", test + " is not a valid postcode - wrong length", subField );
			return false;
		}

		if ( !( isNaN( test.charAt(0) ) ) )
		{ 
			validator.validationError( "startsWithNumber", test + " is not a valid postcode - cannot start with a number", subField );
			return false;
		}

		if ( isNaN( test.charAt( size - 3 ) ) )
		{ 
			validator.validationError( "alphaInWrongPlace", test + " is not a valid postcode - alpha character in wrong position", subField );
			return false;
		}

		if ( !( isNaN( test.charAt( size - 2 ) ) ) )
		{ 
			validator.validationError( "numberInWrongPlace1", test + " is not a valid postcode - number in wrong position", subField );
			return false;
		}

		if ( !( isNaN( test.charAt( size - 1 ) ) ) )
		{ 
			validator.validationError( "numberInWrongPlace2", test + " is not a valid postcode - number in wrong position", subField );
			return false;
		}

		if ( !( test.charAt( size - 4) == " " ) )
		{
			validator.validationError( "spaceInWrongPlace", test + " is not a valid postcode - no space or space in wrong position", subField );
			return false;
		}

		var firstSpaceIndex = test.indexOf( " " );
		var lastSpaceIndex = test.lastIndexOf( " " );
		if ( firstSpaceIndex != lastSpaceIndex )
		{ 
			validator.validationError( "tooManySpaces", test + " is not a valid postcode - only one space allowed", subField );
			return false;
		}
		
		return true;
	}
}