import mx.effects.Tween;

[Style(name="angleFrom",type="Number")]
[Style(name="angleTo",type="Number")]
class effects.Rotate extends mx.effects.TweenEffect
{
	var className:String = "Rotate";
	var origX:Number;
	var origY:Number;
	var centerX:Number;
	var centerY:Number;

	[Inspectable(defaultValue=0)]
	var angleFrom:Number;
	[Inspectable(defaultValue=360)]
	var angleTo:Number;

	function Rotate(targetObj:Object)
	{
		target = targetObj;
	}
	
	function playEffect():Void
	{
		super.playEffect();
		// Find the center point.
		centerX = origX; // + (target.width / 2);
		centerY = origY; // + (target.height / 2);
		if(angleFrom == undefined)
		{
			angleFrom = 0;
		}
		if(angleTo == undefined)
		{
			angleTo = 360;
		}
		tween = new Tween(this, angleFrom, angleTo, duration);
		if (easing)
			tween.setEasingEquation(target, easing);
		// Set back to initial position before the screen refreshes.
		onTweenUpdate(angleFrom);
	}

	function onTweenUpdate( val ) : Void
	{
		target._rotation = val;
		var radVal:Number = Math.PI * val/180;
		// Set target._x and target._y to avoid returning the target object
		// to its original location.
		target._x = centerX - (target.width / 2)*Math.cos(radVal) +
		(target.height / 2)*Math.sin(radVal);
		target._y = centerY - (target.width / 2)*Math.sin(radVal) -
		(target.height / 2)*Math.cos(radVal);
	}
	
	function getAffectedProperties() : Array
	{
		return ["_rotation"];
	}
}