package com.iterationtwo.boe.dao;

import java.sql.*;
import java.util.*;
import com.iterationtwo.boe.vo.*;

public class CreditCardDAO
{
    public static CreditCardDAO getInstance()
    {
      if ( dao == null )
        dao = new CreditCardDAO();

      return dao;

    }

//------------------------------------------------------------------------------

    private CreditCardDAO()
    {
	try
	{
          Class.forName( "org.gjt.mm.mysql.Driver" );
	}
	catch (Exception e)
	{
          e.printStackTrace();
	}
    }

//------------------------------------------------------------------------------

    public List getCreditCards() throws SQLException
    {
    	Connection con = null;
        List results = new ArrayList();
        try
        {
            con = DriverManager.getConnection( url );

            PreparedStatement stmt = con.prepareStatement( "SELECT * FROM credit_cards" );

            ResultSet rs = stmt.executeQuery();
            while (rs.next())
            {
                CreditCardVO cc = new CreditCardVO();
                cc.setId( rs.getInt( "id" ) );
                cc.setInterestRate( rs.getInt( "interest_rate" ) );
                cc.setBalanceTransferInterestRate( rs.getInt( "balance_transfer_interest_rate" ) );
                cc.setHasInterestFreePeriod( rs.getBoolean( "has_interest_free_period" ) );
                cc.setCharitable( rs.getBoolean( "is_charitable" ) );
                cc.setAirmiles( rs.getBoolean( "has_airmiles" ) );
                cc.setCashback( rs.getBoolean( "has_cashback" ) );
                cc.setSummary( rs.getString( "summary" ) );
                cc.setBlurb( rs.getString( "blurb" ) );
                cc.setAsset( rs.getString( "asset" ) );

                results.add( cc );
            }
        }
        finally
        {
            try
            {
                con.close();
            }
            catch (Exception ignored) {}
        }
        return results;
    }

//------------------------------------------------------------------------------

    private static CreditCardDAO dao;
    private static String url = "jdbc:mysql://localhost:3306/flexbook?autoReconnect=true";
}
